
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h" 
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "EventResource_op.h"

using namespace qmf::org::matahariproject;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  EventResource_op::packageName  = string ("org.matahariproject");
string  EventResource_op::eventName    = string ("resource_op");
uint8_t EventResource_op::md5Sum[16]   =
    {0x7e,0x16,0x8,0xbf,0x28,0x6c,0xa8,0xf0,0x8f,0xdf,0x63,0xb2,0xf,0x41,0xcb,0xe6};

EventResource_op::EventResource_op (const std::string& _name,
        const std::string& _action,
        const uint32_t _interval,
        const uint32_t _rc,
        const uint32_t _sequence,
        const int64_t _timestamp,
        const std::string& _rsc_type,
        const std::string& _rsc_class,
        const std::string& _rsc_provider) :
    name(_name),
    action(_action),
    interval(_interval),
    rc(_rc),
    sequence(_sequence),
    timestamp(_timestamp),
    rsc_type(_rsc_type),
    rsc_class(_rsc_class),
    rsc_provider(_rsc_provider)
{}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
}

void EventResource_op::registerSelf(ManagementAgent* agent)
{
    agent->registerEvent(packageName, eventName, md5Sum, writeSchema);
}

void EventResource_op::writeSchema (std::string& schema)
{
    const int _bufSize = 65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_EVENT);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (eventName);   // Event Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (9); // Argument Count

    // Arguments
    ft.clear();
    ft[NAME] = "name";
    ft[TYPE] = TYPE_SSTR;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "action";
    ft[TYPE] = TYPE_SSTR;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "interval";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "rc";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "sequence";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "timestamp";
    ft[TYPE] = TYPE_ABSTIME;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "rsc_type";
    ft[TYPE] = TYPE_SSTR;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "rsc_class";
    ft[TYPE] = TYPE_SSTR;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "rsc_provider";
    ft[TYPE] = TYPE_SSTR;
    buf.putMap(ft);


    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}

void EventResource_op::encode(std::string& _sBuf) const
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);

    buf.putShortString(name);
    buf.putShortString(action);
    buf.putLong(interval);
    buf.putLong(rc);
    buf.putLong(sequence);
    buf.putLongLong(timestamp);
    buf.putShortString(rsc_type);
    buf.putShortString(rsc_class);
    buf.putShortString(rsc_provider);


    uint32_t _bufLen = buf.getPosition();
    buf.reset();

    buf.getRawData(_sBuf, _bufLen);
}

void EventResource_op::mapEncode(::qpid::types::Variant::Map& map) const
{
    using namespace ::qpid::types;
    map["name"] = ::qpid::types::Variant(name);
    map["action"] = ::qpid::types::Variant(action);
    map["interval"] = ::qpid::types::Variant(interval);
    map["rc"] = ::qpid::types::Variant(rc);
    map["sequence"] = ::qpid::types::Variant(sequence);
    map["timestamp"] = ::qpid::types::Variant(timestamp);
    map["rsc_type"] = ::qpid::types::Variant(rsc_type);
    map["rsc_class"] = ::qpid::types::Variant(rsc_class);
    map["rsc_provider"] = ::qpid::types::Variant(rsc_provider);

}
