
#ifndef _MANAGEMENT_RESOURCE_OP_
#define _MANAGEMENT_RESOURCE_OP_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementEvent.h"

namespace qmf {
namespace org {
namespace matahariproject {


class EventResource_op : public ::qpid::management::ManagementEvent
{
  private:
    static void writeSchema (std::string& schema);
    static std::string packageName;
    static std::string eventName;
    static uint8_t md5Sum[MD5_LEN];

    const std::string& name;
    const std::string& action;
    const uint32_t interval;
    const uint32_t rc;
    const uint32_t sequence;
    const int64_t timestamp;
    const std::string& rsc_type;
    const std::string& rsc_class;
    const std::string& rsc_provider;


  public:
    writeSchemaCall_t getWriteSchemaCall(void) { return writeSchema; }

    EventResource_op(const std::string& _name,
        const std::string& _action,
        const uint32_t _interval,
        const uint32_t _rc,
        const uint32_t _sequence,
        const int64_t _timestamp,
        const std::string& _rsc_type,
        const std::string& _rsc_class,
        const std::string& _rsc_provider);
    ~EventResource_op() {};

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getEventName() const { return eventName; }
    uint8_t* getMd5Sum() const { return md5Sum; }
    uint8_t getSeverity() const { return 6; }
    void encode(std::string& buffer) const;
    void mapEncode(::qpid::types::Variant::Map& map) const;
};

}}}

#endif  /*!_MANAGEMENT_RESOURCE_OP_*/
