
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h"
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "Host.h"

#include <iostream>
#include <sstream>

using namespace qmf::org::matahariproject;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  Host::packageName  = string ("org.matahariproject");
string  Host::className    = string ("host");
uint8_t Host::md5Sum[MD5_LEN]   =
    {0x1b,0x1c,0x6a,0x2f,0x0,0x60,0x52,0xf6,0x33,0xfd,0x84,0x5f,0x7e,0xbc,0xe0,0x47};

Host::Host (ManagementAgent*, Manageable* _core) :
    ManagementObject(_core)
{
    
    uuid = "";
    hostname = "";
    os = "";
    arch = "";
    wordsize = 0;
    memory = 0;
    swap = 0;
    cpu_count = 0;
    cpu_cores = 0;
    cpu_model = "";
    cpu_flags = "";
    update_interval = 0;
    last_updated = 0;
    sequence = 0;
    free_mem = 0;
    free_swap = 0;
    load = ::qpid::types::Variant::Map();
    process_statistics = ::qpid::types::Variant::Map();



}

Host::~Host ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Host::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Host::writeSchema (std::string& schema)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (12); // Config Element Count
    buf.putShort       (6); // Inst Element Count
    buf.putShort       (3); // Method Count

    // Properties
    ft.clear();
    ft[NAME] = "uuid";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Host UUID";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "hostname";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Hostname";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "os";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The installed operating system.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "arch";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The host's architecture";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "wordsize";
    ft[TYPE] = TYPE_U8;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[UNIT] = "bit";
    ft[DESC] = "The wordsize for the host";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "memory";
    ft[TYPE] = TYPE_U64;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[UNIT] = "kb";
    ft[DESC] = "Amount of primary memory for host";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "swap";
    ft[TYPE] = TYPE_U64;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[UNIT] = "kb";
    ft[DESC] = "Amount of swap for host";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "cpu_count";
    ft[TYPE] = TYPE_U8;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The number of physical CPUs.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "cpu_cores";
    ft[TYPE] = TYPE_U8;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The total number of processor cores.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "cpu_model";
    ft[TYPE] = TYPE_LSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The processor(s) model description.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "cpu_flags";
    ft[TYPE] = TYPE_LSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The processor(s) CPU flags.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "update_interval";
    ft[TYPE] = TYPE_U32;
    ft[ACCESS] = ACCESS_RW;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[UNIT] = "s";
    ft[DESC] = "The interval at which the host sends out heartbeats and refreshes statistics.";
    buf.putMap(ft);


    // Statistics
    ft.clear();
    ft[NAME] = "last_updated";
    ft[TYPE] = TYPE_ABSTIME;
    ft[DESC] = "The last time a heartbeat occurred.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "sequence";
    ft[TYPE] = TYPE_U32;
    ft[DESC] = "The heartbeat sequence number.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "free_mem";
    ft[TYPE] = TYPE_U64;
    ft[UNIT] = "kb";
    ft[DESC] = "Amount of available memory for host";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "free_swap";
    ft[TYPE] = TYPE_U64;
    ft[UNIT] = "kb";
    ft[DESC] = "Amount of available swap for host";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "load";
    ft[TYPE] = TYPE_FTABLE;
    ft[DESC] = "The one/five/fifteen minute load average";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "process_statistics";
    ft[TYPE] = TYPE_FTABLE;
    ft[DESC] = "Number of processes in each possible state";
    buf.putMap(ft);


    // Methods
    ft.clear();
    ft[NAME] =  "identify";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Tells the host to beep its pc speaker.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "shutdown";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Shutdown node";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "reboot";
    ft[ARGCOUNT] = 0;
    ft[DESC] = "Reboot node";
    buf.putMap(ft);


    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}




std::string Host::getKey() const
{
    std::stringstream key;

    key << uuid;
    return key.str();
}



void Host::mapEncodeValues (::qpid::types::Variant::Map& _map,
                                              bool includeProperties,
                                              bool includeStatistics)
{
    using namespace ::qpid::types;
    Mutex::ScopedLock mutex(accessLock);

    if (includeProperties) {
        configChanged = false;
    _map["uuid"] = ::qpid::types::Variant(uuid);
    _map["hostname"] = ::qpid::types::Variant(hostname);
    _map["os"] = ::qpid::types::Variant(os);
    _map["arch"] = ::qpid::types::Variant(arch);
    _map["wordsize"] = ::qpid::types::Variant(wordsize);
    _map["memory"] = ::qpid::types::Variant(memory);
    _map["swap"] = ::qpid::types::Variant(swap);
    _map["cpu_count"] = ::qpid::types::Variant(cpu_count);
    _map["cpu_cores"] = ::qpid::types::Variant(cpu_cores);
    _map["cpu_model"] = ::qpid::types::Variant(cpu_model);
    _map["cpu_flags"] = ::qpid::types::Variant(cpu_flags);
    _map["update_interval"] = ::qpid::types::Variant(update_interval);

    }

    if (includeStatistics) {
        instChanged = false;




    _map["last_updated"] = ::qpid::types::Variant(last_updated);
    _map["sequence"] = ::qpid::types::Variant(sequence);
    _map["free_mem"] = ::qpid::types::Variant(free_mem);
    _map["free_swap"] = ::qpid::types::Variant(free_swap);
    _map["load"] = ::qpid::types::Variant(load);
    _map["process_statistics"] = ::qpid::types::Variant(process_statistics);


    // Maintenance of hi-lo statistics


    }
}

void Host::mapDecodeValues (const ::qpid::types::Variant::Map& _map)
{
    ::qpid::types::Variant::Map::const_iterator _i;
    Mutex::ScopedLock mutex(accessLock);

    if ((_i = _map.find("uuid")) != _map.end()) {
        uuid = (_i->second).getString();
    }
    if ((_i = _map.find("hostname")) != _map.end()) {
        hostname = (_i->second).getString();
    }
    if ((_i = _map.find("os")) != _map.end()) {
        os = (_i->second).getString();
    }
    if ((_i = _map.find("arch")) != _map.end()) {
        arch = (_i->second).getString();
    }
    if ((_i = _map.find("wordsize")) != _map.end()) {
        wordsize = _i->second;
    }
    if ((_i = _map.find("memory")) != _map.end()) {
        memory = _i->second;
    }
    if ((_i = _map.find("swap")) != _map.end()) {
        swap = _i->second;
    }
    if ((_i = _map.find("cpu_count")) != _map.end()) {
        cpu_count = _i->second;
    }
    if ((_i = _map.find("cpu_cores")) != _map.end()) {
        cpu_cores = _i->second;
    }
    if ((_i = _map.find("cpu_model")) != _map.end()) {
        cpu_model = (_i->second).getString();
    }
    if ((_i = _map.find("cpu_flags")) != _map.end()) {
        cpu_flags = (_i->second).getString();
    }
    if ((_i = _map.find("update_interval")) != _map.end()) {
        update_interval = _i->second;
    }

}

void Host::doMethod (string& methodName, const ::qpid::types::Variant::Map&, ::qpid::types::Variant::Map& outMap, const string& userId)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "identify") {
        ::qpid::management::ArgsNone ioArgs;
        bool allow = coreObject->AuthorizeMethod(METHOD_IDENTIFY, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_IDENTIFY, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "shutdown") {
        ::qpid::management::ArgsNone ioArgs;
        bool allow = coreObject->AuthorizeMethod(METHOD_SHUTDOWN, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_SHUTDOWN, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "reboot") {
        ::qpid::management::ArgsNone ioArgs;
        bool allow = coreObject->AuthorizeMethod(METHOD_REBOOT, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_REBOOT, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    outMap["_status_code"] = (uint32_t) status;
    outMap["_status_text"] = Manageable::StatusText(status, text);
}
