
#ifndef _MANAGEMENT_HOST_
#define _MANAGEMENT_HOST_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"

namespace qpid {
    namespace management {
        class ManagementAgent;
    }
}

namespace qmf {
namespace org {
namespace matahariproject {


class Host : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[MD5_LEN];


    // Properties
    std::string uuid;
    std::string hostname;
    std::string os;
    std::string arch;
    uint8_t wordsize;
    uint64_t memory;
    uint64_t swap;
    uint8_t cpu_count;
    uint8_t cpu_cores;
    std::string cpu_model;
    std::string cpu_flags;
    uint32_t update_interval;

    // Statistics
    int64_t  last_updated;
    uint32_t  sequence;
    uint64_t  free_mem;
    uint64_t  free_swap;
    ::qpid::types::Variant::Map  load;
    ::qpid::types::Variant::Map  process_statistics;


  public:
    static void writeSchema(std::string& schema);
    void mapEncodeValues(::qpid::types::Variant::Map& map,
                         bool includeProperties=true,
                         bool includeStatistics=true);
    void mapDecodeValues(const ::qpid::types::Variant::Map& map);
    void doMethod(std::string&           methodName,
                  const ::qpid::types::Variant::Map& inMap,
                  ::qpid::types::Variant::Map& outMap,
                  const std::string& userId);
    std::string getKey() const;


    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }


    Host(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject);
    ~Host();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs
    static const uint32_t METHOD_IDENTIFY = 1;
    static const uint32_t METHOD_SHUTDOWN = 2;
    static const uint32_t METHOD_REBOOT = 3;

    // Accessor Methods
    inline void set_uuid (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        uuid = val;
        configChanged = true;
    }
    inline const std::string& get_uuid() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return uuid;
    }
    inline void set_hostname (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        hostname = val;
        configChanged = true;
    }
    inline const std::string& get_hostname() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return hostname;
    }
    inline void set_os (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        os = val;
        configChanged = true;
    }
    inline const std::string& get_os() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return os;
    }
    inline void set_arch (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        arch = val;
        configChanged = true;
    }
    inline const std::string& get_arch() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return arch;
    }
    inline void set_wordsize (uint8_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        wordsize = val;
        configChanged = true;
    }
    inline uint8_t get_wordsize() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return wordsize;
    }
    inline void set_memory (uint64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        memory = val;
        configChanged = true;
    }
    inline uint64_t get_memory() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return memory;
    }
    inline void set_swap (uint64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        swap = val;
        configChanged = true;
    }
    inline uint64_t get_swap() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return swap;
    }
    inline void set_cpu_count (uint8_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        cpu_count = val;
        configChanged = true;
    }
    inline uint8_t get_cpu_count() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return cpu_count;
    }
    inline void set_cpu_cores (uint8_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        cpu_cores = val;
        configChanged = true;
    }
    inline uint8_t get_cpu_cores() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return cpu_cores;
    }
    inline void set_cpu_model (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        cpu_model = val;
        configChanged = true;
    }
    inline const std::string& get_cpu_model() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return cpu_model;
    }
    inline void set_cpu_flags (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        cpu_flags = val;
        configChanged = true;
    }
    inline const std::string& get_cpu_flags() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return cpu_flags;
    }
    inline void set_update_interval (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        update_interval = val;
        configChanged = true;
    }
    inline uint32_t get_update_interval() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return update_interval;
    }
    inline void set_last_updated (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        last_updated = val;
        instChanged = true;
    }
    inline int64_t get_last_updated() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return last_updated;
    }
    inline void set_sequence (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        sequence = val;
        instChanged = true;
    }
    inline uint32_t get_sequence() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return sequence;
    }
    inline void set_free_mem (uint64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        free_mem = val;
        instChanged = true;
    }
    inline uint64_t get_free_mem() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return free_mem;
    }
    inline void set_free_swap (uint64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        free_swap = val;
        instChanged = true;
    }
    inline uint64_t get_free_swap() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return free_swap;
    }
    inline void set_load (const ::qpid::types::Variant::Map& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        load = val;
        instChanged = true;
    }
    inline const ::qpid::types::Variant::Map& get_load() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return load;
    }
    inline void set_process_statistics (const ::qpid::types::Variant::Map& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        process_statistics = val;
        instChanged = true;
    }
    inline const ::qpid::types::Variant::Map& get_process_statistics() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return process_statistics;
    }

};

}}}

#endif  /*!_MANAGEMENT_HOST_*/
