
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h"
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "Network.h"
#include "ArgsNetworkList.h"
#include "ArgsNetworkStart.h"
#include "ArgsNetworkStop.h"
#include "ArgsNetworkStatus.h"
#include "ArgsNetworkGet_ip_address.h"
#include "ArgsNetworkGet_mac_address.h"

#include <iostream>
#include <sstream>

using namespace qmf::org::matahariproject;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  Network::packageName  = string ("org.matahariproject");
string  Network::className    = string ("network");
uint8_t Network::md5Sum[MD5_LEN]   =
    {0x98,0x8e,0x20,0x47,0x5b,0x3c,0xce,0x60,0xfa,0x4c,0x27,0x7f,0x44,0xc3,0x38,0xaf};

Network::Network (ManagementAgent*, Manageable* _core) :
    ManagementObject(_core)
{
    
    hostname = "";



}

Network::~Network ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Network::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Network::writeSchema (std::string& schema)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (1); // Config Element Count
    buf.putShort       (0); // Inst Element Count
    buf.putShort       (6); // Method Count

    // Properties
    ft.clear();
    ft[NAME] = "hostname";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Hostname";
    buf.putMap(ft);


    // Statistics

    // Methods
    ft.clear();
    ft[NAME] =  "list";
    ft[ARGCOUNT] = 1;
    ft[DESC] = "List IP addresses";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "iface_map";
    ft[TYPE] = TYPE_LIST;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "start";
    ft[ARGCOUNT] = 2;
    ft[DESC] = "Start a network interface";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "iface";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "status";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "stop";
    ft[ARGCOUNT] = 2;
    ft[DESC] = "Stop a network interface";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "iface";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "status";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "status";
    ft[ARGCOUNT] = 2;
    ft[DESC] = "Check a network interface";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "iface";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "status";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "get_ip_address";
    ft[ARGCOUNT] = 2;
    ft[DESC] = "Obtain ip addressof a network interface";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "iface";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "ip";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "get_mac_address";
    ft[ARGCOUNT] = 2;
    ft[DESC] = "Obtain mac address of network interface";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "iface";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "mac";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "O";
    buf.putMap(ft);


    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}




std::string Network::getKey() const
{
    std::stringstream key;

    key << hostname;
    return key.str();
}



void Network::mapEncodeValues (::qpid::types::Variant::Map& _map,
                                              bool includeProperties,
                                              bool includeStatistics)
{
    using namespace ::qpid::types;
    Mutex::ScopedLock mutex(accessLock);

    if (includeProperties) {
        configChanged = false;
    _map["hostname"] = ::qpid::types::Variant(hostname);

    }

    if (includeStatistics) {
        instChanged = false;






    // Maintenance of hi-lo statistics


    }
}

void Network::mapDecodeValues (const ::qpid::types::Variant::Map& _map)
{
    ::qpid::types::Variant::Map::const_iterator _i;
    Mutex::ScopedLock mutex(accessLock);

    if ((_i = _map.find("hostname")) != _map.end()) {
        hostname = (_i->second).getString();
    }

}

void Network::doMethod (string& methodName, const ::qpid::types::Variant::Map& inMap, ::qpid::types::Variant::Map& outMap, const string& userId)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "list") {
        ArgsNetworkList ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        bool allow = coreObject->AuthorizeMethod(METHOD_LIST, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_LIST, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["iface_map"] = ::qpid::types::Variant(ioArgs.o_iface_map);
        return;
    }

    if (methodName == "start") {
        ArgsNetworkStart ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("iface")) != inMap.end()) {
            ioArgs.i_iface = (_i->second).getString();
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_START, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_START, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["status"] = ::qpid::types::Variant(ioArgs.o_status);
        return;
    }

    if (methodName == "stop") {
        ArgsNetworkStop ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("iface")) != inMap.end()) {
            ioArgs.i_iface = (_i->second).getString();
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_STOP, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_STOP, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["status"] = ::qpid::types::Variant(ioArgs.o_status);
        return;
    }

    if (methodName == "status") {
        ArgsNetworkStatus ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("iface")) != inMap.end()) {
            ioArgs.i_iface = (_i->second).getString();
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_STATUS, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_STATUS, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["status"] = ::qpid::types::Variant(ioArgs.o_status);
        return;
    }

    if (methodName == "get_ip_address") {
        ArgsNetworkGet_ip_address ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("iface")) != inMap.end()) {
            ioArgs.i_iface = (_i->second).getString();
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_GET_IP_ADDRESS, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_GET_IP_ADDRESS, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["ip"] = ::qpid::types::Variant(ioArgs.o_ip);
        return;
    }

    if (methodName == "get_mac_address") {
        ArgsNetworkGet_mac_address ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("iface")) != inMap.end()) {
            ioArgs.i_iface = (_i->second).getString();
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_GET_MAC_ADDRESS, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_GET_MAC_ADDRESS, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["mac"] = ::qpid::types::Variant(ioArgs.o_mac);
        return;
    }

    outMap["_status_code"] = (uint32_t) status;
    outMap["_status_text"] = Manageable::StatusText(status, text);
}
