
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h"
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "Resources.h"
#include "ArgsResourcesList_classes.h"
#include "ArgsResourcesList_ocf_providers.h"
#include "ArgsResourcesList.h"
#include "ArgsResourcesDescribe.h"
#include "ArgsResourcesStart.h"
#include "ArgsResourcesStop.h"
#include "ArgsResourcesMonitor.h"
#include "ArgsResourcesInvoke.h"
#include "ArgsResourcesCancel.h"
#include "ArgsResourcesFail.h"

#include <iostream>
#include <sstream>

using namespace qmf::org::matahariproject;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  Resources::packageName  = string ("org.matahariproject");
string  Resources::className    = string ("resources");
uint8_t Resources::md5Sum[MD5_LEN]   =
    {0xce,0xac,0xfd,0x25,0xa1,0x32,0xcd,0xbe,0x88,0x5f,0xe3,0x96,0xec,0x6c,0x64,0x62};

Resources::Resources (ManagementAgent*, Manageable* _core) :
    ManagementObject(_core)
{
    
    hostname = "";



}

Resources::~Resources ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Resources::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Resources::writeSchema (std::string& schema)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (1); // Config Element Count
    buf.putShort       (0); // Inst Element Count
    buf.putShort       (10); // Method Count

    // Properties
    ft.clear();
    ft[NAME] = "hostname";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Hostname";
    buf.putMap(ft);


    // Statistics

    // Methods
    ft.clear();
    ft[NAME] =  "list_classes";
    ft[ARGCOUNT] = 1;
    ft[DESC] = "List known resource classes (OCF, LSB, Upstart, etc)";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "classes";
    ft[TYPE] = TYPE_LIST;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "list_ocf_providers";
    ft[ARGCOUNT] = 1;
    ft[DESC] = "List known OCF providers (if supported)";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "providers";
    ft[TYPE] = TYPE_LIST;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "list";
    ft[ARGCOUNT] = 2;
    ft[DESC] = "List known resource types for a given provider";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "provider";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "types";
    ft[TYPE] = TYPE_LIST;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "describe";
    ft[ARGCOUNT] = 4;
    ft[DESC] = "Obtain XML description of a resource";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "class";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "provider";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "type";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "xml";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "start";
    ft[ARGCOUNT] = 7;
    ft[DESC] = "Start a resource";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "class";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "provider";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "type";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "parameters";
    ft[TYPE] = TYPE_FTABLE;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "timeout";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "rc";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "stop";
    ft[ARGCOUNT] = 7;
    ft[DESC] = "Stop a resource";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "class";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "provider";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "type";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "parameters";
    ft[TYPE] = TYPE_FTABLE;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "timeout";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "rc";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "monitor";
    ft[ARGCOUNT] = 8;
    ft[DESC] = "Check the health of a resource";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "class";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "provider";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "type";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "interval";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "parameters";
    ft[TYPE] = TYPE_FTABLE;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "timeout";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "rc";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "invoke";
    ft[ARGCOUNT] = 9;
    ft[DESC] = "Perform a custom action on a resource";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "class";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "provider";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "type";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "action";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "interval";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "parameters";
    ft[TYPE] = TYPE_FTABLE;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "timeout";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "rc";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "cancel";
    ft[ARGCOUNT] = 7;
    ft[DESC] = "Cancel a pending or running action on a resource";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "class";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "provider";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "type";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "action";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "interval";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "timeout";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "fail";
    ft[ARGCOUNT] = 4;
    ft[DESC] = "Indicate a resource has failed";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "class";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "provider";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "type";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);


    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}




std::string Resources::getKey() const
{
    std::stringstream key;

    key << hostname;
    return key.str();
}



void Resources::mapEncodeValues (::qpid::types::Variant::Map& _map,
                                              bool includeProperties,
                                              bool includeStatistics)
{
    using namespace ::qpid::types;
    Mutex::ScopedLock mutex(accessLock);

    if (includeProperties) {
        configChanged = false;
    _map["hostname"] = ::qpid::types::Variant(hostname);

    }

    if (includeStatistics) {
        instChanged = false;






    // Maintenance of hi-lo statistics


    }
}

void Resources::mapDecodeValues (const ::qpid::types::Variant::Map& _map)
{
    ::qpid::types::Variant::Map::const_iterator _i;
    Mutex::ScopedLock mutex(accessLock);

    if ((_i = _map.find("hostname")) != _map.end()) {
        hostname = (_i->second).getString();
    }

}

void Resources::doMethod (string& methodName, const ::qpid::types::Variant::Map& inMap, ::qpid::types::Variant::Map& outMap, const string& userId)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "list_classes") {
        ArgsResourcesList_classes ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        bool allow = coreObject->AuthorizeMethod(METHOD_LIST_CLASSES, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_LIST_CLASSES, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["classes"] = ::qpid::types::Variant(ioArgs.o_classes);
        return;
    }

    if (methodName == "list_ocf_providers") {
        ArgsResourcesList_ocf_providers ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        bool allow = coreObject->AuthorizeMethod(METHOD_LIST_OCF_PROVIDERS, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_LIST_OCF_PROVIDERS, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["providers"] = ::qpid::types::Variant(ioArgs.o_providers);
        return;
    }

    if (methodName == "list") {
        ArgsResourcesList ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("provider")) != inMap.end()) {
            ioArgs.i_provider = (_i->second).getString();
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_LIST, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_LIST, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["types"] = ::qpid::types::Variant(ioArgs.o_types);
        return;
    }

    if (methodName == "describe") {
        ArgsResourcesDescribe ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("class")) != inMap.end()) {
            ioArgs.i_class = (_i->second).getString();
        }
        if ((_i = inMap.find("provider")) != inMap.end()) {
            ioArgs.i_provider = (_i->second).getString();
        }
        if ((_i = inMap.find("type")) != inMap.end()) {
            ioArgs.i_type = (_i->second).getString();
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_DESCRIBE, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_DESCRIBE, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["xml"] = ::qpid::types::Variant(ioArgs.o_xml);
        return;
    }

    if (methodName == "start") {
        ArgsResourcesStart ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("name")) != inMap.end()) {
            ioArgs.io_name = (_i->second).getString();
        }
        if ((_i = inMap.find("class")) != inMap.end()) {
            ioArgs.io_class = (_i->second).getString();
        }
        if ((_i = inMap.find("provider")) != inMap.end()) {
            ioArgs.io_provider = (_i->second).getString();
        }
        if ((_i = inMap.find("type")) != inMap.end()) {
            ioArgs.io_type = (_i->second).getString();
        }
        if ((_i = inMap.find("parameters")) != inMap.end()) {
            ioArgs.i_parameters = (_i->second).asMap();
        }
        if ((_i = inMap.find("timeout")) != inMap.end()) {
            ioArgs.i_timeout = _i->second;
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_START, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_START, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["name"] = ::qpid::types::Variant(ioArgs.io_name);
        outMap["class"] = ::qpid::types::Variant(ioArgs.io_class);
        outMap["provider"] = ::qpid::types::Variant(ioArgs.io_provider);
        outMap["type"] = ::qpid::types::Variant(ioArgs.io_type);
        outMap["rc"] = ::qpid::types::Variant(ioArgs.o_rc);
        return;
    }

    if (methodName == "stop") {
        ArgsResourcesStop ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("name")) != inMap.end()) {
            ioArgs.io_name = (_i->second).getString();
        }
        if ((_i = inMap.find("class")) != inMap.end()) {
            ioArgs.io_class = (_i->second).getString();
        }
        if ((_i = inMap.find("provider")) != inMap.end()) {
            ioArgs.io_provider = (_i->second).getString();
        }
        if ((_i = inMap.find("type")) != inMap.end()) {
            ioArgs.io_type = (_i->second).getString();
        }
        if ((_i = inMap.find("parameters")) != inMap.end()) {
            ioArgs.i_parameters = (_i->second).asMap();
        }
        if ((_i = inMap.find("timeout")) != inMap.end()) {
            ioArgs.i_timeout = _i->second;
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_STOP, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_STOP, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["name"] = ::qpid::types::Variant(ioArgs.io_name);
        outMap["class"] = ::qpid::types::Variant(ioArgs.io_class);
        outMap["provider"] = ::qpid::types::Variant(ioArgs.io_provider);
        outMap["type"] = ::qpid::types::Variant(ioArgs.io_type);
        outMap["rc"] = ::qpid::types::Variant(ioArgs.o_rc);
        return;
    }

    if (methodName == "monitor") {
        ArgsResourcesMonitor ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("name")) != inMap.end()) {
            ioArgs.io_name = (_i->second).getString();
        }
        if ((_i = inMap.find("class")) != inMap.end()) {
            ioArgs.io_class = (_i->second).getString();
        }
        if ((_i = inMap.find("provider")) != inMap.end()) {
            ioArgs.io_provider = (_i->second).getString();
        }
        if ((_i = inMap.find("type")) != inMap.end()) {
            ioArgs.io_type = (_i->second).getString();
        }
        if ((_i = inMap.find("interval")) != inMap.end()) {
            ioArgs.io_interval = _i->second;
        }
        if ((_i = inMap.find("parameters")) != inMap.end()) {
            ioArgs.i_parameters = (_i->second).asMap();
        }
        if ((_i = inMap.find("timeout")) != inMap.end()) {
            ioArgs.i_timeout = _i->second;
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_MONITOR, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_MONITOR, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["name"] = ::qpid::types::Variant(ioArgs.io_name);
        outMap["class"] = ::qpid::types::Variant(ioArgs.io_class);
        outMap["provider"] = ::qpid::types::Variant(ioArgs.io_provider);
        outMap["type"] = ::qpid::types::Variant(ioArgs.io_type);
        outMap["interval"] = ::qpid::types::Variant(ioArgs.io_interval);
        outMap["rc"] = ::qpid::types::Variant(ioArgs.o_rc);
        return;
    }

    if (methodName == "invoke") {
        ArgsResourcesInvoke ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("name")) != inMap.end()) {
            ioArgs.io_name = (_i->second).getString();
        }
        if ((_i = inMap.find("class")) != inMap.end()) {
            ioArgs.io_class = (_i->second).getString();
        }
        if ((_i = inMap.find("provider")) != inMap.end()) {
            ioArgs.io_provider = (_i->second).getString();
        }
        if ((_i = inMap.find("type")) != inMap.end()) {
            ioArgs.io_type = (_i->second).getString();
        }
        if ((_i = inMap.find("action")) != inMap.end()) {
            ioArgs.io_action = (_i->second).getString();
        }
        if ((_i = inMap.find("interval")) != inMap.end()) {
            ioArgs.io_interval = _i->second;
        }
        if ((_i = inMap.find("parameters")) != inMap.end()) {
            ioArgs.i_parameters = (_i->second).asMap();
        }
        if ((_i = inMap.find("timeout")) != inMap.end()) {
            ioArgs.i_timeout = _i->second;
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_INVOKE, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_INVOKE, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["name"] = ::qpid::types::Variant(ioArgs.io_name);
        outMap["class"] = ::qpid::types::Variant(ioArgs.io_class);
        outMap["provider"] = ::qpid::types::Variant(ioArgs.io_provider);
        outMap["type"] = ::qpid::types::Variant(ioArgs.io_type);
        outMap["action"] = ::qpid::types::Variant(ioArgs.io_action);
        outMap["interval"] = ::qpid::types::Variant(ioArgs.io_interval);
        outMap["rc"] = ::qpid::types::Variant(ioArgs.o_rc);
        return;
    }

    if (methodName == "cancel") {
        ArgsResourcesCancel ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("name")) != inMap.end()) {
            ioArgs.io_name = (_i->second).getString();
        }
        if ((_i = inMap.find("class")) != inMap.end()) {
            ioArgs.io_class = (_i->second).getString();
        }
        if ((_i = inMap.find("provider")) != inMap.end()) {
            ioArgs.io_provider = (_i->second).getString();
        }
        if ((_i = inMap.find("type")) != inMap.end()) {
            ioArgs.io_type = (_i->second).getString();
        }
        if ((_i = inMap.find("action")) != inMap.end()) {
            ioArgs.io_action = (_i->second).getString();
        }
        if ((_i = inMap.find("interval")) != inMap.end()) {
            ioArgs.io_interval = _i->second;
        }
        if ((_i = inMap.find("timeout")) != inMap.end()) {
            ioArgs.i_timeout = _i->second;
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_CANCEL, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_CANCEL, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["name"] = ::qpid::types::Variant(ioArgs.io_name);
        outMap["class"] = ::qpid::types::Variant(ioArgs.io_class);
        outMap["provider"] = ::qpid::types::Variant(ioArgs.io_provider);
        outMap["type"] = ::qpid::types::Variant(ioArgs.io_type);
        outMap["action"] = ::qpid::types::Variant(ioArgs.io_action);
        outMap["interval"] = ::qpid::types::Variant(ioArgs.io_interval);
        return;
    }

    if (methodName == "fail") {
        ArgsResourcesFail ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("name")) != inMap.end()) {
            ioArgs.io_name = (_i->second).getString();
        }
        if ((_i = inMap.find("class")) != inMap.end()) {
            ioArgs.io_class = (_i->second).getString();
        }
        if ((_i = inMap.find("provider")) != inMap.end()) {
            ioArgs.io_provider = (_i->second).getString();
        }
        if ((_i = inMap.find("type")) != inMap.end()) {
            ioArgs.io_type = (_i->second).getString();
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_FAIL, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_FAIL, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["name"] = ::qpid::types::Variant(ioArgs.io_name);
        outMap["class"] = ::qpid::types::Variant(ioArgs.io_class);
        outMap["provider"] = ::qpid::types::Variant(ioArgs.io_provider);
        outMap["type"] = ::qpid::types::Variant(ioArgs.io_type);
        return;
    }

    outMap["_status_code"] = (uint32_t) status;
    outMap["_status_text"] = Manageable::StatusText(status, text);
}
