
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h"
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "Services.h"
#include "ArgsServicesList.h"
#include "ArgsServicesEnable.h"
#include "ArgsServicesDisable.h"
#include "ArgsServicesStart.h"
#include "ArgsServicesStop.h"
#include "ArgsServicesStatus.h"
#include "ArgsServicesCancel.h"
#include "ArgsServicesFail.h"
#include "ArgsServicesDescribe.h"

#include <iostream>
#include <sstream>

using namespace qmf::org::matahariproject;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  Services::packageName  = string ("org.matahariproject");
string  Services::className    = string ("services");
uint8_t Services::md5Sum[MD5_LEN]   =
    {0x5d,0x1d,0x94,0xa9,0x1,0xc,0x85,0x4c,0xd0,0xc6,0xad,0x5f,0xb4,0x2,0x84,0x81};

Services::Services (ManagementAgent*, Manageable* _core) :
    ManagementObject(_core)
{
    
    hostname = "";



}

Services::~Services ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Services::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Services::writeSchema (std::string& schema)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (1); // Config Element Count
    buf.putShort       (0); // Inst Element Count
    buf.putShort       (9); // Method Count

    // Properties
    ft.clear();
    ft[NAME] = "hostname";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Hostname";
    buf.putMap(ft);


    // Statistics

    // Methods
    ft.clear();
    ft[NAME] =  "list";
    ft[ARGCOUNT] = 1;
    ft[DESC] = "List known system services";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "services";
    ft[TYPE] = TYPE_LIST;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "enable";
    ft[ARGCOUNT] = 1;
    ft[DESC] = "Configure a system service to start at boot";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "disable";
    ft[ARGCOUNT] = 1;
    ft[DESC] = "Configure a system service _not_ to start at boot";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "start";
    ft[ARGCOUNT] = 3;
    ft[DESC] = "Start a system service";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "timeout";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "rc";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "stop";
    ft[ARGCOUNT] = 3;
    ft[DESC] = "Stop a system service";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "timeout";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "rc";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "status";
    ft[ARGCOUNT] = 4;
    ft[DESC] = "Check the health of a system service";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "interval";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "timeout";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "rc";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "cancel";
    ft[ARGCOUNT] = 3;
    ft[DESC] = "Cancel a pending or running action on a system service";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "action";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "interval";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "fail";
    ft[ARGCOUNT] = 1;
    ft[DESC] = "Raise a failure event for a system service";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "describe";
    ft[ARGCOUNT] = 2;
    ft[DESC] = "Obtain XML description of a system service";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "xml";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "O";
    buf.putMap(ft);


    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}




std::string Services::getKey() const
{
    std::stringstream key;

    key << hostname;
    return key.str();
}



void Services::mapEncodeValues (::qpid::types::Variant::Map& _map,
                                              bool includeProperties,
                                              bool includeStatistics)
{
    using namespace ::qpid::types;
    Mutex::ScopedLock mutex(accessLock);

    if (includeProperties) {
        configChanged = false;
    _map["hostname"] = ::qpid::types::Variant(hostname);

    }

    if (includeStatistics) {
        instChanged = false;






    // Maintenance of hi-lo statistics


    }
}

void Services::mapDecodeValues (const ::qpid::types::Variant::Map& _map)
{
    ::qpid::types::Variant::Map::const_iterator _i;
    Mutex::ScopedLock mutex(accessLock);

    if ((_i = _map.find("hostname")) != _map.end()) {
        hostname = (_i->second).getString();
    }

}

void Services::doMethod (string& methodName, const ::qpid::types::Variant::Map& inMap, ::qpid::types::Variant::Map& outMap, const string& userId)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "list") {
        ArgsServicesList ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        bool allow = coreObject->AuthorizeMethod(METHOD_LIST, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_LIST, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["services"] = ::qpid::types::Variant(ioArgs.o_services);
        return;
    }

    if (methodName == "enable") {
        ArgsServicesEnable ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("name")) != inMap.end()) {
            ioArgs.i_name = (_i->second).getString();
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_ENABLE, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_ENABLE, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "disable") {
        ArgsServicesDisable ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("name")) != inMap.end()) {
            ioArgs.i_name = (_i->second).getString();
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_DISABLE, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_DISABLE, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "start") {
        ArgsServicesStart ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("name")) != inMap.end()) {
            ioArgs.io_name = (_i->second).getString();
        }
        if ((_i = inMap.find("timeout")) != inMap.end()) {
            ioArgs.i_timeout = _i->second;
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_START, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_START, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["name"] = ::qpid::types::Variant(ioArgs.io_name);
        outMap["rc"] = ::qpid::types::Variant(ioArgs.o_rc);
        return;
    }

    if (methodName == "stop") {
        ArgsServicesStop ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("name")) != inMap.end()) {
            ioArgs.io_name = (_i->second).getString();
        }
        if ((_i = inMap.find("timeout")) != inMap.end()) {
            ioArgs.i_timeout = _i->second;
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_STOP, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_STOP, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["name"] = ::qpid::types::Variant(ioArgs.io_name);
        outMap["rc"] = ::qpid::types::Variant(ioArgs.o_rc);
        return;
    }

    if (methodName == "status") {
        ArgsServicesStatus ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("name")) != inMap.end()) {
            ioArgs.io_name = (_i->second).getString();
        }
        if ((_i = inMap.find("interval")) != inMap.end()) {
            ioArgs.io_interval = _i->second;
        }
        if ((_i = inMap.find("timeout")) != inMap.end()) {
            ioArgs.i_timeout = _i->second;
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_STATUS, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_STATUS, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["name"] = ::qpid::types::Variant(ioArgs.io_name);
        outMap["interval"] = ::qpid::types::Variant(ioArgs.io_interval);
        outMap["rc"] = ::qpid::types::Variant(ioArgs.o_rc);
        return;
    }

    if (methodName == "cancel") {
        ArgsServicesCancel ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("name")) != inMap.end()) {
            ioArgs.i_name = (_i->second).getString();
        }
        if ((_i = inMap.find("action")) != inMap.end()) {
            ioArgs.i_action = (_i->second).getString();
        }
        if ((_i = inMap.find("interval")) != inMap.end()) {
            ioArgs.i_interval = _i->second;
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_CANCEL, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_CANCEL, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "fail") {
        ArgsServicesFail ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("name")) != inMap.end()) {
            ioArgs.io_name = (_i->second).getString();
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_FAIL, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_FAIL, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["name"] = ::qpid::types::Variant(ioArgs.io_name);
        return;
    }

    if (methodName == "describe") {
        ArgsServicesDescribe ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("name")) != inMap.end()) {
            ioArgs.i_name = (_i->second).getString();
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_DESCRIBE, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_DESCRIBE, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["xml"] = ::qpid::types::Variant(ioArgs.o_xml);
        return;
    }

    outMap["_status_code"] = (uint32_t) status;
    outMap["_status_text"] = Manageable::StatusText(status, text);
}
